package org.sgine.math.store

trait NumericStore extends Function1[Int, Double] {
	def storeType: StoreType
	
	def length: Int
	
	def modify(index: Int, value: Double): Unit
	
	def copyFrom(store: NumericStore, offset: Int = 0) = {
		for (index <- 0 until length) {
			modify(index, store(index + offset))
		}
	}
}