package org.sgine.math.store

import org.sgine.core.Enumerated

sealed trait StoreType {
	def createStore(length: Int): NumericStore
}

object StoreType extends Enumerated[StoreType] {
	case object Simple extends StoreType {
		def createStore(length: Int) = throw new NullPointerException("Simple store cannot create stores")
	}
	
	case object SimpleArray extends StoreType {
		def createStore(length: Int) = ArrayStore(length)
	}
	
	var Default = Simple
	
	StoreType(Simple, SimpleArray)
}